﻿Imports System.Collections.Specialized
Imports System.Configuration
Imports C1.Win.C1Chart
Imports Salon_and_Spa_Studio_2019.SalonAndSpaDb2DataSet
Public Class FormOccupancyChart
    Dim GroupedData As IEnumerable(Of IGrouping(Of Object, tblRoomOccupancyRow))
    Dim rooms As IList(Of String)
    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub
    Private Sub FormChart_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'SalonAndSpaDb2DataSet.tblRoomOccupancy' table. You can move, or remove it, as needed.
        Me.TblRoomOccupancyTableAdapter.Fill(Me.SalonAndSpaDb2DataSet.tblRoomOccupancy)

        InitChart()
    End Sub
    Private Sub InitChart()
        Dim grp0 = C1ChartRoomOccupancy.ChartGroups.Group0
        grp0.ChartData.SeriesList.Clear()

        grp0.ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Gantt
        Dim Data = Me.SalonAndSpaDb2DataSet.tblRoomOccupancy 'GetData()
        GroupedData = Data.GroupBy(Function(row) New With {Key .RoomName = row.RoomName})

        ' Read the OccupancyRoomNames, RoomColours from the User Settings.
        ' Read the OccupancyIncrement from the User Settings.
        Dim settingsSection = DirectCast(ConfigurationManager.GetSection("userSettings/Salon_and_Spa_Studio_2019.My.MySettings"), ClientSettingsSection)
        C1ChartRoomOccupancy.ChartArea.AxisX.AnnoMethod = AnnotationMethodEnum.ValueLabels
        rooms = New List(Of String)

        Dim idx = 0
        For Each setting As SettingElement In settingsSection.Settings
            If setting.Name.ToLower().Contains("roomname") Then
                Dim name = setting.Value.ValueXml.InnerText
                C1ChartRoomOccupancy.ChartArea.AxisX.ValueLabels.Add(idx, name)
                Dim ser = grp0.ChartData.SeriesList.AddNewSeries()
                ser.Label = name
                rooms.Add(name)
                If GroupedData.Any(Function(row) row.Key.RoomName = name) Then
                    Dim item = GroupedData.FirstOrDefault(Function(row) row.Key.RoomName = name)
                    Dim startTimes = item?.Select(Of DateTime)(Function(row) row.StartTime).ToArray()
                    Dim endTimes = item?.Select(Of DateTime)(Function(row) row.EndTime).ToArray()
                    ser.Y.CopyDataIn(startTimes)
                    ser.Y1.CopyDataIn(endTimes)
                End If
                'No need of colors collection now as we have stored our room colors in App.Config
                'ser.FillStyle.Color1 = colors(idx) 
                idx += 1
            ElseIf setting.Name.ToLower().Contains("roomcolour") Then
                'Fetch the color from App.Config settings and apply it directly
                grp0.ChartData.SeriesList(Int32.Parse(setting.Name.Last().ToString()) - 1).FillStyle.Color1 = Color.FromName(setting.Value.ValueXml.InnerText)

            ElseIf setting.Name.ToLower().Contains("increment") Then
                C1ChartRoomOccupancy.ChartArea.AxisY.GridMinor.Spacing = (1.0 / (24 * 60)) * Int32.Parse(setting.Value.ValueXml.InnerText)
            End If
        Next
        C1ChartRoomOccupancy.ChartArea.AxisX.Max = idx

        ' Remove the Axes Default Texts.
        C1ChartRoomOccupancy.ChartArea.AxisX.Text = vbNullString
        C1ChartRoomOccupancy.ChartArea.AxisY.Text = vbNullString
        ' Set the Axes Default Texts to Bold.
        C1ChartRoomOccupancy.ChartArea.AxisX.Font = New Font("Segoe-UI", 10, FontStyle.Bold)
        C1ChartRoomOccupancy.ChartArea.AxisY.Font = New Font("Segoe-UI", 10, FontStyle.Bold)

        C1ChartRoomOccupancy.ChartArea.Inverted = True
        C1ChartRoomOccupancy.ChartArea.AxisX.Reversed = True
        '
        Dim startDate = New DateTime(Data.First().StartTime.Year, Data.First().StartTime.Month, Data.First().StartTime.Day, 8, 0, 0)
        Dim endDate = New DateTime(Data.Last().EndTime.Year, Data.Last().EndTime.Month, Data.Last().EndTime.Day, 18, 0, 0)

        C1ChartRoomOccupancy.ChartArea.AxisY.Min = startDate.ToOADate()
        C1ChartRoomOccupancy.ChartArea.AxisY.Max = endDate.ToOADate()
        C1ChartRoomOccupancy.ChartArea.AxisY.AutoMinor = False

        C1ChartRoomOccupancy.ChartArea.AxisY.AnnoMethod = C1.Win.C1Chart.AnnotationMethodEnum.ValueLabels
        Dim dt = startDate
        While dt <= endDate
            C1ChartRoomOccupancy.ChartArea.AxisY.ValueLabels.Add(dt.ToOADate(), dt.ToString("hh:00 tt"))
            dt = dt.AddHours(1)
        End While

        C1ChartRoomOccupancy.ChartArea.AxisY.GridMajor.Color = Color.Black
        C1ChartRoomOccupancy.ChartArea.AxisY.GridMinor.Visible = True
        C1ChartRoomOccupancy.ChartArea.AxisY.AnnotationRotation = 30


        C1ChartRoomOccupancy.ChartArea.PlotArea.Boxed = True

        C1ChartRoomOccupancy.ToolTip.Enabled = True
        C1ChartRoomOccupancy.ToolTip.SelectAction = C1.Win.C1Chart.SelectActionEnum.MouseOver
        AddHandler C1ChartRoomOccupancy.ShowTooltip, AddressOf C1ChartRoomOccupancy_ShowTooltip
    End Sub

    Private Sub C1ChartRoomOccupancy_ShowTooltip(sender As Object,
                                                 e As ShowTooltipEventArgs)
        If sender.GetType() = GetType(ChartDataSeries) Then
            Dim position = C1ChartRoomOccupancy.PointToClient(Control.MousePosition)
            Dim serIdx = 0, ptIdx = 0, dist = 0
            C1ChartRoomOccupancy.ChartGroups.Group0.CoordToDataIndex(position.X, position.Y,
                                                                     CoordinateFocusEnum.XandYCoord, serIdx, ptIdx, dist)
            Dim serItem = GroupedData.FirstOrDefault(Function(row) row.Key.RoomName = rooms(serIdx))
            Dim item = serItem?.ElementAt(ptIdx)
            e.TooltipText = If(item Is Nothing, "", "Room: " & item.RoomName & vbCrLf &
                            "Client: " & item.ClientName & vbCrLf &
                            "User: " & item.UserName & vbCrLf &
                            "From: " & item.StartTime.ToString("hh:mm tt") & " - To: " & item.EndTime.ToString("hh:mm tt"))
        End If
    End Sub

End Class
Public Class DataItem
    Public Property Task As String
    Public Property StartTime As DateTime
    Public Property EndTime As DateTime
End Class